﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.8
@EndOfDesignText@
' =======================================================================================
' Description ...: Form Generator for B4J
' Requirement(s).: B4J 6.51
' Author ........: Giovanni Rossati (El Condor)
' Version........: 0.5.8
' Date...........: 25 November 2018
' License........: Free to use without any warranties
' =======================================================================================
#If JAVA

#End If
'Class module
Sub Class_Globals
	Private fx As JFX
	Dim fh_Data As Map = CreateMap()		' Reference to node of data
	Dim fh_FieldsType As Map = CreateMap()	' Reference to fields type
	Dim numericTypes As Map = CreateMap("N":True,"DN":True,"S":True)	' nodes with numeric values
	Dim comparator As Map = CreateMap("=":1,">":2,"<":4,">=":3,"<=":5,"<>":6)
	Dim defLength As Map = CreateMap("S":5,"QS":8,"F":30,"DN":9,"N":7,"P":16,"R":12,"F":30,"WF":30,"DATE":13)
	Dim nodeSynonims As Map = CreateMap("BACKGROUND":"GROUND","COMMENT":"C","RDB":"R","FILE":"F","WFILE":"WF", _
										"HIDDEN":"H","DEFAULTS":"DEFAULT","RDEFAULTS":"RDEFAULT")
	Dim fh_yesToExit As Boolean = True	' used for block exit
	Private fh_module As Object	' calling Module
	Private fh_returnSub As String	' receiving sub
	Private fh_handleSub As String	' handle events sub
	Private fh_panel As Pane	' Reference to panel handle
	Dim widgetRef As Map	' Reference to node of data
	Private Elem As Map		' data fields
	Private Defaults As Map	' fields defaults
	Private checks As Map	' checks on nodes, key is field name
	Private required As Map	' required nodes, key is field name
	Private after As Map	' after key is Node to set after value
	Private menuList As List	' menu
	Dim nElem As Int		' Elements number
	Dim Limits As Map		' for numerics fields
	Dim mapValues As Map	' combo/radio key value
	Dim hiddensMap As Map	' Hiddens values
	Dim field() As String
	Dim wWidget As Int		' maximum node width (characters)
	Dim pnl As Pane
	Dim lbl As Label
	Dim lblTitle As Label
	Dim Matcher1 As Matcher
	Dim Sections(1,3) As String		' sections array
	Dim Section As Int = -1			' actual section
'	Dim VR As VoiceRecognition
'	VR.Initialize("VR")
	Private focusedText As TextField
	Private IsUpdatingText As Boolean = False
	Private frm As Form
	Dim screenW,screenH As Int
	Dim charWidth As Double = Ceil(98/14)+1	' EWeOAaSsIiMw09 occupe 98 in font 12
	Private lineHeight As Int  = 17				' 17 (fontsize = 12)
	Public version As String = "0.5.7"
	Public re As String = "^\s*([-+]?\d+)\s+([-+]?\d+)\s*$"	' for caputure n1 n2 (ex -100 100)
	Public labels() As Object = Array("","center-left","")
End Sub
Public Sub Initialize (Parent As Form,w As Long,h As Long)
	' Init the form. Form size is set to best size
	frm.Initialize("frm", w, h)
	frm.Resizable = True
	If Parent.Stylesheets = Null Then frm.Stylesheets.AddAll(Parent.Stylesheets)
	screenW = w
	screenH = h
End Sub
Sub fg(params As String,Module As Object,retSub As String,handleSub As String) As String()
	params = params.Replace(Chr(10),"")
	fh_returnSub = retSub
	fh_handleSub = handleSub
	fh_module = Module
	Dim prefix As String = ""
	Matcher1 = Regex.Matcher2("(.*?;)(Section,.*)",Regex.CASE_INSENSITIVE,params)
	If Matcher1.Find Then
		Dim beforeSection As String = Matcher1.Group(1)
		params = Matcher1.Group(2)
	End If	
	If Not(Regex.IsMatch2("^\s*section.*",Regex.CASE_INSENSITIVE,params)) Then prefix = "Section,fh_section;"
	Dim s() As String = Regex.split2("^section,|;\s*section,",Regex.CASE_INSENSITIVE,prefix & params.Replace(Chr(10),""))
	Dim Sections(s.Length-1,3) As String
	For i = 1 To s.Length -1
		Matcher1 = Regex.Matcher("(.*?);(.*)",s(i))
		If Matcher1.Find Then
			Dim sectorParm() As String = Regex.Split(",",Matcher1.Group(1))	' force three fields
			Sections(i-1,0) = beforeSection & Matcher1.Group(2)	' prefixed by possibly views commons to all sections
			Sections(i-1,1) = sectorParm(0)		' section name
			Sections(i-1,2) = implodeFrom(",",sectorParm,1,sectorParm.Length-1)			' check conditions
		End If
	Next
	fh_Data.Clear
	fh_FieldsType.Clear
	Section = -1
	CallSubDelayed2(Me,"fh_answer",fh_Data)
End Sub
Sub fh_answer(Data As Map)
	Dim button As String = Data.GetDefault("fh_button","First stroke")
	If button = "Cancel" Then
		CallSubDelayed2(fh_module,fh_returnSub,Data)
		cleanForm
	Else
		If button = "fh_Back" Then
			Section = Section - 1
		Else
			Section = Section + 1
		End If
		If Section >= Sections.Length Then
			CallSubDelayed2(fh_module,fh_returnSub,Data)
			cleanForm
		Else
			' check if section is conditioned
			Dim conditions() As String = Regex.Split(",",Sections(Section,2))
			Dim condition As Boolean = True
			For i = 0 To conditions.Length - 1
				If conditions(i) <> "" Then
					Matcher1 = Regex.Matcher("(.+?)\s*(=|<=|>=|<>|>|<)\s*(.*)",conditions(i))
					If Not(Matcher1.Find) Then Continue
					Dim fieldName As String = Matcher1.Group(1)
					Dim operand As String = deMask(Matcher1.Group(3))
					Dim operator As String = Matcher1.Group(2)
					If Not(compare(numericTypes.GetDefault(fh_FieldsType.GetDefault(fieldName,False),False),fh_Data.GetDefault(fieldName,""),operator,operand)) Then 
						condition = False
					End If
				End If
			Next
			If condition Then
				lblTitle.Initialize("")
				CSSUtils.SetStyleProperty(lblTitle, "-fx-font", "bold 20 sans-serif")	' font family must be present
				lblTitle.text = "Section " & Sections(Section,1)
				CSSUtils.SetStyleProperty(lblTitle, "-fx-alignment","center")
				CallSubDelayed2("","fgSection",Sections(Section,0))
			Else
				CallSubDelayed2("","fgSection","")	' this because there is not goto
			End If
		End If
	End If
End Sub
private Sub cleanForm
	fh_panel.RemoveAllNodes
	frm.Close
	Section = -1
End Sub
Sub fgSection(params As String)
	If params = "" Then
		CallSubDelayed2(Me,"fh_answer",fh_Data)
		Return
	End If
	widgetRef.Initialize
	Elem.Initialize
	checks.Initialize
	required.Initialize
	Limits.Initialize
	mapValues.Initialize
	Defaults.Initialize
	hiddensMap.Initialize
	menuList.Initialize
	after.initialize
'	Dim rdb As RadioButton
	Dim widgets() As String
	Dim width, btnWidth,btnHeight,offsetX, offsetBtn, offsetY,deltaY As Int
	Dim wdgType As String
	Dim allButtons As Map = CreateMap("fh_Back":Array As String("<--",""),"Cancel":Array As String("Cancel",""), _
		"Reset":Array As String("Reset",""),"Ok":Array As String("Ok",""))
	Dim afterButtonCount As Int = 0	' count callback buttons
	Dim fromTo() As String	' array for limits (used also for ground colors and defaults)
	Dim typeForm As String	' typeForm: T = text, B = buttons, C = combo box (ComboBox)
	offsetX = 5
	offsetY = 40
	width = 50	' width ?
	deltaY = 2 * lineHeight
	btnWidth = 70
	btnHeight = deltaY - 8
	widgets = Regex.Split(";\s*", "Ground;" & params)	' for default
	fh_panel.Initialize("")
	fh_panel.Tag = "fh_panel"
	Dim dimLabels As Int = 0
	lbl.Initialize("")
'	CSSUtils.SetBackgroundColor(lbl,fx.Colors.ARGB(0,0,0,0))
	lbl.style = "-fx-background-color: transparent;-fx-text-fill: silver;"
	CSSUtils.SetStyleProperty(lbl, "-fx-font", "bold 12 serif")	' font family must be present
	' normalize request: control and clean parameters
	For iw = 0 To widgets.Length - 1
		If Left(widgets(iw),1) = "'" Or widgets(iw) = "" Then Continue	' comment
		field = Regex.Split(",", widgets(iw) & ",,,,,,*")
		field(field.Length-1) = ""	' remove *
		field(0) = field(0).ToUpperCase	' upper case
		field(0) = nodeSynonims.GetDefault(field(0),field(0))
		If field(0) = "TIME" Then		' time
			field(0) = "QS"				' -> Qualitative Slide
			field(3) = 4				' length
			field(5) = "0|1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20|21|22|23"
		End If
		If field(0) = "TITLE" Then		' title
			lblTitle.text = field(2)
			If field(3) <> "" Then CSSUtils.SetStyleProperty(lblTitle, "-fx-text-fill",decodeColor(field(3)))	' color title
			If field(4) <> "" Then lblTitle.Style = "-fx-background-color: " & decodeColor(field(4) & ";" & lblTitle.Style)' ground color title
			widgetRef.Put(field(1),Array As Object (lblTitle,"TITLE"))
		Else if field(0) = "DEFAULT" Or field(0) = "RDEFAULT" Then		' defaults Node
			For ir=1 To field.Length - 1
				If field(ir) <> "" Then
					fromTo = Regex.split("\s*:",field(ir) & ":")
					If field(0) = "RDEFAULT" Then fromTo = extractRandom(fromTo)
					If fromTo.Length = 2 Then Defaults.Put(fromTo(0),deMask(fromTo(1)))
				End If
			Next
		Else if field(0) = "REQUIRED" Then							' required Node
			For ir=1 To field.Length - 1
				required.Put(field(ir),"")
			Next
		Else If field(0) = "H" Then			' Hiddens fields
			hiddensMap.Put(field(1),implodeFrom(",", field,2,100))
			widgetRef.Put(field(1),Array As Object (0,"H",0))
		Else If field(0) = "CHECK" Then		' checks on fields
			Matcher1 = Regex.Matcher2("(.+?)\s*(=|<=|>=|<>|>|<|is)\s*.*",Regex.CASE_INSENSITIVE,field(1))
			If Matcher1.Find Then
				addCheck(Matcher1.Group(1),Array As String(field(1),field(2)))		' check and possible error message
			End If
		Else If field(0) = "AFTER" Then		' after
			If fh_FieldsType.ContainsKey(field(1)) And fh_FieldsType.ContainsKey(field(2)) Then
				after.Put(field(1),field(2))
			Else
				field(0) = "C"				
				If Not(fh_FieldsType.ContainsKey(field(1))) Then
					field(2) = field(1) & " not exists! After ignored"
				Else
					field(2) = field(2) & " not exists! After ignored"					
				End If
				field(3) = field(2).length
				field(1) = ""
				Elem.Put(field(1),field)
			End If
		Else If field(0) = "GROUND" Then	' Background 	ex linear-gradient(to bottom right, red, black)
			Dim bckgColor As String
			If field(1) = "" Then field(1) = "FFC0C0C0"
			Dim prms() As String = Regex.split("[ ]+",field(1))
			If prms.Length = 1 Then bckgColor = decodeColor(prms(0))
			If prms.Length > 1 Then
				bckgColor = "linear-gradient("
				If prms.Length > 2 Then bckgColor = bckgColor & "to " & implodeFrom(" ",prms,2,3) & ","
				bckgColor = bckgColor & decodeColor(prms(0)) & "," & decodeColor(prms(1)) & ")"
			End If
			CSSUtils.SetStyleProperty(fh_panel, "-fx-background-color",bckgColor)	'fx.Colors. RGB(240, 255, 240))
		Else If field(0) = "MENU" Then		' Menu
			menuList.Add(implodeFrom(",",field,1,3))
		Else If field(0) = "LABEL" Then
			labels(2) = field(3)	' text after label
			If field(2).ToUpperCase = "RIGHT" Then labels(1) = "center-right"
		Else
			If field(2) = "" Then field(2) = field(1)	' if there is not label
			field(2) = deMask(field(2))
			field(4) = deMask(field(4).Trim())
			field(5) = deMask(field(5))
			If field(3) = "" Then
				If defLength.ContainsKey(field(0)) Then
					field(3) =  defLength.get(field(0))
				Else
					field(3) = Max(20,field(4).Length)	' length widget
				End If
			End If
			If field(0) = "" Then field(0) = "T" 	' default
			If field(0) = "C" Then 		' comment
				field(3) = field(2).length
				field(1) = ""
			Else
				If Not(Defaults.ContainsKey(field(1))) Then 
					Defaults.Put(field(1),field(4))	' set defaults map
				End If
			End If
			If field(0) = "B" And allButtons.ContainsKey(field(1)) Then
				Dim a() As String = allButtons.Get(field(1))
				a(0) = field(2)
				allButtons.Put(field(1),a)	'change description of standard buttons
				Continue
			End If
			If field(0) = "S" Then
				If field(5) = "" Then field(5) = "0 100"	' default slide
				fromTo = Regex.split(" ",field(5) & " 100")
				Limits.Put(field(1) & "Min",Min(fromTo(0),fromTo(1)))
				Limits.Put(field(1) & "Max",Max(fromTo(0),fromTo(1)))
				Limits.Put(field(1) & "Delta", Abs(Limits.get(field(1) & "Max") - Limits.get(field(1) & "Min")))
			End If
			If field(0) = "QS" Then
				If field(5) = "" Then field(5) = "lack|of|values"
				Private listQS As List = splitKeyValue(field(1),field(5))
				Limits.Put(field(1),listQS)
				Limits.Put(field(1) & "Min",0)
				Limits.Put(field(1) & "Max",listQS.Size - 1)
				Limits.Put(field(1) & "Delta", listQS.Size - 1)
			End If
			'		dummy = c.MeasureStringWidth(field(2),Typeface.DEFAULT,12)
			If field(0) <> "C" Then
				Dim labelWidth As Int = textWidth(field(2) & labels(2))
				If labelWidth > dimLabels Then dimLabels = labelWidth
			End If
			Elem.Put(field(1),field)
			fh_FieldsType.Put(field(1),field(0))	' for type numeric or string
		End If
	Next
	If dimLabels > 0.2 * screenW Then dimLabels = 0.2 * screenW	' ct maximum
	dimLabels = dimLabels + 5
	nElem = Elem.Size
	' compute maximum widget width
	wWidget = (screenW - 2 * offsetX - dimLabels-5) / charWidth
	Dim btns(20dip) As Button
	typeForm = ""				' for type of final buttons
	' create form -------------------------------------------------------------------------------------
	fh_panel.AddNode(lblTitle,0 , 0, frm.Width, 30)
	For i = 0 To nElem - 1
		field = Elem.GetValueAt(i)
		Dim lblx As Label = CopyObject(lbl)
		lblx.Initialize("")
		lblx.text = field(2) & labels(2)
		CSSUtils.SetStyleProperty(lblx,"-fx-alignment",labels(1))
		wdgType = field(0)
		Dim txtProto As TextField
		If wdgType = "B" Then
			allButtons.Put(field(1),Array As String (field(2) , field(5)))
			' remove Ok button if there is anothe button without callback or not after button 13 May 17
			If after.ContainsKey(field(1)) Then
				afterButtonCount = afterButtonCount + 1
			Else
				Dim k() As String = allButtons.GetDefault("Ok",Array As String("",""))
				If k(0) = "Ok" And field(5) = "" Then allButtons.Remove("Ok")
			End If
		Else If wdgType = "CKB" Then
			Dim ckbProto As CheckBox
			ckbProto.Initialize("checkBox")
			ckbProto.TextSize = 12
			ckbProto.text = " " & field(5)
			ckbProto.Tag = field(1)
			If after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1))) Then
				Dim afterNode As Node = getFromNodeMap(after.Get(field(1)),0)
				fh_panel.AddNode(ckbProto,afterNode.Left+afterNode.PrefWidth+10, afterNode.Top , field(3) * charWidth, deltaY-2dip)
			Else
				fh_panel.AddNode(ckbProto ,offsetX+5 + dimLabels ,  offsetY-5 , field(3) * charWidth, deltaY-2dip)
			End If
			widgetRef.Put(field(1),Array As Object (ckbProto,wdgType,lblx))
		Else If wdgType = "R" Then			' *** Radiobuttons
			Dim rdbList As List,j As Int
			rdbList = splitKeyValue(field(1),field(5))
			Dim rdbGroup(rdbList.size) As RadioButton
			pnl.Initialize("")
			widgetRef.Put(field(1),Array As Object (pnl,wdgType,lblx,0))
			For j = 0 To rdbList.Size-1
				rdbGroup(j).Initialize("RadioButton")
				rdbGroup(j).TextSize = 12
				rdbGroup(j).text = rdbList.get(j)
				rdbGroup(j).Tag = field(1)
				pnl.AddNode(rdbGroup(j),j*field(3) * charWidth,0,field(3) * charWidth, deltaY-2)
				rdbList.set(j, rdbGroup(j))
			Next
			rdbGroup(0).GroupRadioButtons(rdbList)
			If after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1))) Then
				Dim afterNode As Node = getFromNodeMap(after.Get(field(1)),0)
				fh_panel.AddNode(pnl,afterNode.Left + afterNode.PrefWidth + 10, afterNode.Top-5 , field(3) * charWidth, deltaY-2)
			Else
				fh_panel.AddNode(pnl,offsetX+5 + dimLabels, offsetY-5 , field(3) * charWidth, deltaY-2)
			End If
		Else If wdgType = "CMB" Or wdgType = "CMX"  Or wdgType = "CMT" Then	' *** ComboBox
			Dim event As String = iIF(wdgType = "CMX","comboCMX","combos")
			Dim cmb As ComboBox
			cmb.Initialize(event) 'All combos share the same event sub
			Dim yText As Int = offsetY
			If wdgType = "CMT" Then cmb.Editable = True
			fh_panel.AddNode(cmb,offsetX+5 + dimLabels, offsetY, Min(field(3),wWidget) * charWidth, deltaY-6)
			If wdgType = "CMX" Then yText = offsetY+deltaY
			cmb.Tag = field(1)
			cmb.Items.AddAll(splitKeyValue(field(1),field(5)))
			cmb.TooltipText = field(2)	' the label is prompt
			widgetRef.Put(field(1),Array As Object (cmb,wdgType,lblx,cmb))
			If wdgType = "CMX" Then		' combo + text added				
				Dim txtArea As TextArea
				txtArea.Initialize("")
				txtArea.WrapText = True
				widgetRef.Put(field(1),Array As Object (txtArea,wdgType,lblx,cmb))
				fh_panel.AddNode(txtArea,offsetX+7 + dimLabels,  yText, iIF(field(3) > wWidget, wWidget,field(3)) * charWidth, getHeight(Ceil(field(3)/wWidget)))
			End If
		Else If wdgType = "F"  Or wdgType = "WF" Then
			txtProto = setText(field)
			widgetRef.Put(field(1),Array As Object (txtProto,wdgType,lblx))
			fh_panel.AddNode(txtProto,offsetX+5 + dimLabels , offsetY, field(3) * charWidth,  getHeight(Ceil(field(3)/wWidget)))
			Dim btnx As Button = addButton("...","File",offsetX+10 + dimLabels+field(3) * charWidth,offsetY-2)
			btnx.MouseCursor = fx.Cursors.HAND
			If field(5) <> "" Then txtProto.PromptText = field(5)
			btnx.Tag = field(1)
		Else If wdgType = "U" Then
			txtProto = setText(field)
			Dim uLbl As Label
			uLbl.Initialize("")
			uLbl.text = field(4)
			widgetRef.Put(field(1),Array As Object (uLbl,wdgType,lblx))
			fh_panel.AddNode(uLbl,offsetX+5 + dimLabels, offsetY+3, iIF(field(3) > wWidget, wWidget,field(3)) * charWidth, getHeight(Ceil(field(3)/wWidget)))
		else If wdgType = "C" Then 	' comment
			Dim comment As Label
			comment.Initialize("")
			comment.Text = field(2)
		else If wdgType = "DATE" Then 	' Date
			Dim dt As DatePicker
			dt.Initialize("")
			If field(5) <> "" Then
				dt.DateFormat = field(5)
			End If
			If field(6) <> "" Then dt.TooltipText = field(6)
			dt.Tag = field(1)
			fh_panel.AddNode(dt,offsetX+5 + dimLabels, offsetY+3, field(3) * charWidth, deltaY*0.7)
			widgetRef.Put(field(1),Array As Object (dt,wdgType,lblx))
		Else
			txtProto = setText(field)
			If wdgType = "DN" Or wdgType = "S" Or wdgType = "N" Then	' numerics fields
				CSSUtils.SetStyleProperty(txtProto, "-fx-alignment", "CENTER-RIGHT")
			End If
			widgetRef.Put(field(1),Array As Object (txtProto,wdgType,lblx,txtProto))
			If wdgType = "S" Or wdgType = "QS" Then	' *** slide ***
				If Limits.get(field(1) & "Delta") < width*2.5 Or wdgType = "QS" Then txtProto.Editable = False
				Dim align As String = "center"
				If wdgType = "S" Then align = align & "-right"
				CSSUtils.SetBorder(txtProto,1,fx.Colors.LightGray,5)
				CSSUtils.SetBackgroundColor(txtProto, fx.Colors.ARGB(255,240,240,240))
				CSSUtils.SetStyleProperty(txtProto, "-fx-alignment", align)
				Dim sldProto As Slider
				sldProto.Initialize("Slide")
				sldProto.Tag = field(1)	' widget name
				sldProto.MinValue = Limits.get(field(1) & "Min")
				sldProto.maxValue = Limits.get(field(1) & "Max")
				widgetRef.Put(field(1),Array As Object (sldProto,wdgType,lblx,txtProto))
				fh_panel.AddNode(sldProto,offsetX+5 + dimLabels, offsetY, width*3, deltaY*0.7)
				fh_panel.AddNode(txtProto,offsetX+8 + dimLabels + width*3 , offsetY, iIF(field(3) > wWidget, wWidget,field(3)) * charWidth, getHeight(1)-2)
			Else	' this is a text field I suppose
				If field(5) <> "" Then txtProto.PromptText = field(5)
				fh_panel.AddNode(txtProto,offsetX+5 + dimLabels , offsetY, iIF(field(3) > wWidget, wWidget,field(3)) * charWidth, getHeight(Ceil(field(3)/wWidget)))
			End If
		End If
		If wdgType = "CMB" Then
			typeForm = typeForm & "C"
		Else
			If wdgType <> "C" Then typeForm = typeForm & wdgType
		End If
		Private pnlHeight As Int = 0
		If wdgType <> "B" Then
			pnlHeight = lineHeight+getHeight(Ceil(field(3)/wWidget))
			If wdgType = "C" Then	' comment
				pnlHeight = getHeight(Ceil(charWidth*field(3)/(frm.Width-2*offsetX)))+10
				fh_panel.AddNode(comment,offsetX, 5+offsetY, frm.Width-2*offsetX, pnlHeight-10)	' getHeight(Ceil(field(3)/wWidget))
			Else
				If Not(after.ContainsKey(field(1)) And widgetRef.ContainsKey(after.Get(field(1)))) Then
					fh_panel.AddNode(lblx,offsetX, offsetY, dimLabels, deltaY-10)
				Else
					pnlHeight = 0
				End If
				If wdgType = "CMX" Then pnlHeight = pnlHeight + deltaY
			End If
			offsetY = offsetY + pnlHeight
		End If
	Next
	' what buttons?
	If typeForm <> "C" Then ' if no only one ComboBox
		If Sections.Length > 1  Then
			If Section < Sections.Length -1 Then
				allButtons.put("fh_Forward",Array As String("-->",""))
				allButtons.Remove("Ok")
			End If
		End If
		If Sections.Length = 1 Or Section = 0 Then allButtons.Remove("fh_Back")
		Dim j As Int = 0
		If Regex.IsMatch("U*",typeForm) Then	' this intercept also a form whith no nodes or only comments
			allButtons.Remove("Reset")	' only Unmodifiables data
			If allButtons.ContainsKey("Ok") Then allButtons.Remove("Ok")	' only Unmodifiables data
		End If
		offsetBtn = (frm.Width - (allButtons.Size - afterButtonCount)*(btnWidth+5)) * 0.5
		For i = 0 To allButtons.Size - 1
			Dim Name As String = allButtons.GetKeyAt(i)
			Dim k() As String = allButtons.GetValueAt(i)
			Dim Match As Matcher
			field = Elem.Get(allButtons.GetKeyAt(i))	' recovery of node
			Match = Regex.Matcher2("\.(png|jpg|jpeg|gif|ico)$",Regex.CASE_INSENSITIVE,k(0))
			If Match.Find  Then
				btns(i).Initialize("buttons")
				Dim iv As Image
				iv.initialize(File.DirAssets, k(0))
				CSSUtils.SetBackgroundImage(btns(i),File.DirAssets,k(0))
				CSSUtils.SetBackgroundColor(btns(i),fx.Colors.ARGB(0,0,0,0))
				CSSUtils.SetStyleProperty(btns(i), "-fx-background-position","center")
				btns(i).Tag = Name
				widgetRef.Put(allButtons.GetKeyAt(i),Array As Object (btns(i),fh_FieldsType.GetDefault(k(0),"BG"),0,k(1)))
				If after.ContainsKey(Name) And widgetRef.ContainsKey(Name) Then
					Dim afterNode As Node = getFromNodeMap(after.Get(Name),0)
					fh_panel.AddNode(btns(i),afterNode.Left+afterNode.PrefWidth+20,afterNode.Top,iv.Width, iv.Height)
				Else
					fh_panel.AddNode(btns(i),offsetBtn +j*btnWidth,offsetY+6,iv.width, iv.height)
					j = j + 1
				End If
			Else
				Dim eventButton As String = "buttons"
				If Name = "Cancel" Or Name = "Reset" Then eventButton = Name
				btns(i).Initialize(eventButton)
				btns(i).text = k(0)
				btns(i).Tag = Name
				widgetRef.Put(allButtons.GetKeyAt(i),Array As Object (btns(i),fh_FieldsType.GetDefault(k(0),"B"),0,k(1)))
				If after.ContainsKey(allButtons.GetKeyAt(i)) And widgetRef.ContainsKey(Name) Then
					Dim afterNode As Node = getFromNodeMap(after.Get(Name),0)
					fh_panel.AddNode(btns(i),afterNode.Left+afterNode.PrefWidth+20,afterNode.Top,btnWidth, btnHeight)
				Else
					fh_panel.AddNode(btns(i),offsetBtn +j*btnWidth,offsetY+6,btnWidth, btnHeight)
					j = j + 1
				End If
			End If
			btns(i).MouseCursor = fx.cursors.Hand
		Next
	End If
	If Sections.Length > 1 And fh_Data.Size > 0 Then
		setDefaults(False)
	Else
		setDefaults(True)
	End If
	' manage menu
	frm.RootPane.AddNode(fh_panel,0,0,frm.Width,frm.Height)
	If menuList.Size > 0 Then
		frm.RootPane.AddNode(createMenu(implode(";",menuList)),0,0,300,40)
	End If
	frm.Title = lblTitle.Text
	frm.Show
	handleEvents(Array As Object ("fh_start","Start"))
End Sub
Private Sub setDefaults(reset As Boolean)	' true if is from reset button
	For i=0 To Defaults.Size - 1
		Dim key As String = Defaults.GetKeyAt(i)
		setValue(key,Defaults.GetValueAt(i))
		If Not(reset) Then
			If fh_Data.ContainsKey(key) Then setValue(key,fh_Data.Get(key))	' data from another section
		End If
	Next
End Sub
Sub extractRandom(xx() As String) As String() 	' xx(0) name, xx(1) defaults
	Dim retxx(2) As String = Array As String(xx(0),"")
	If xx.Length <> 2 Then 
		Dim Fields() As String = Elem.GetDefault(xx(0),"")	' if no defauults, take item list
		retxx(1) = Fields(5)
	Else
		retxx(1) = xx(1)
	End If
	Dim Match As Matcher
	Match = Regex.Matcher(re, retxx(1))
	If Match.Find Then
		retxx(1) =  Rnd(Match.Group(1),Match.Group(2) + 1)
	Else
		Dim rString() As String = Regex.Split("\|",Regex.Replace("\|.*?:","|" & retxx(1),"|"))
		Dim rndx As Int = 0
		If rString.Length > 1 Then rndx = Rnd(1,rString.Length)
		retxx(1) = rString(rndx)
	End If
	Return retxx
End Sub
Private Sub getHeight(rows As Int) As Int
	Return rows * lineHeight	' font size 12 height = 17
End Sub
Sub mask(data As String) As String	' mask comma AND semicolon
	Dim s As String = data.Replace(",","#44")
	Return s.Replace(";","#59")
End Sub
Sub deMask(text As String)	As String
	Dim pattern As String = "#[X]?([\d0-9ABCDEF]+)" 'one or more digits
	Dim Match As Matcher
	Match = Regex.Matcher2(pattern, Regex.CASE_INSENSITIVE,text)
	Do While Match.Find
		Dim radix As Int = 10
		If Match.GetStart(1) - Match.GetStart(0) = 2 Then radix = 16
		text = Regex.Replace(Match.Match,text,Chr(Bit.ParseInt(Match.Match.SubString(Match.GetStart(1) - Match.GetStart(0)),radix)))
	Loop
	Return text
End Sub
Sub Left(s As String,l As Int) As String
If l < s.Length Then Return s.SubString2(0,l)
Return s
End Sub
Sub Right(s As String,l As Int) As String
If l < s.Length Then Return s.SubString(s.Length-l)
Return s
End Sub
Sub iIF(Cond As Boolean,First As Object,Second As Object) As Object
	If Cond Then Return First
	Return Second
End Sub
Sub splitKeyValue(name As String,data As String) As List ' split key value (combos, qualitative sliders AND option buttons)
	Dim dt(),key,value As String,k As Int 
	Dim lst As List
	lst.Initialize
	If data.Length > 0 Then
		dt = Regex.Split("\|", data)
		For j = 0 To dt.Length - 1
			If dt(j).IndexOf(":") < 0 Then dt(j)=dt(j) & ":" & dt(j)
			k = dt(j).IndexOf(":")
			key = dt(j).SubString2(0,k)
			value = dt(j).SubString(k+1)
			mapValues.Put(name & value,key)
			mapValues.Put(name & key,value)
			lst.add(value)
		Next
	End If
	Return lst
End Sub
Private Sub Cancel_Action
	handleEvents(Array As Object ("Cancel","CLICK",Sender))
	fh_Data.Put("fh_button", "Cancel")
	CallSubDelayed2(Me,"fh_answer",fh_Data)
End Sub
Private Sub Reset_Action
	setDefaults(True)
	handleEvents(Array As Object ("fh_reset","Reset"))
End Sub
private Sub File_action
	Dim s As Button = Sender
	Private fc As FileChooser
	fc.Initialize
	Dim field() As String = Elem.Get(s.Tag)
	Dim sExtension As String = implodeFrom(",",field,6,16) ' file type is from II extra field
	fc.Title = field(2)
	Dim f As String = valueOf(s.Tag)
	fc.SetExtensionFilter(field(5),Regex.Split(",", sExtension))
	If File.Exists("",f) Then
		Private m As Map = pathinfo(f)
		fc.InitialDirectory = m.Get("dirname")
		fc.InitialFileName = m.Get("filename")
	End If
	If field(0) = "WF" Then
		f = fc.ShowSave(frm)
	Else
		f = fc.ShowOpen(frm)
	End If
	If f <> "" Then
		setValue(s.Tag,f)
	End If
End Sub
Private Sub Buttons_Action		' *** exit routin
	Dim btnNode As Node = Sender
	Dim btnTag As String = btnNode.Tag
	handleEvents(Array As Object (btnTag,"CLICK",btnNode))
'	Dim	fh_CallBackSub() As String = Regex.Split("\.",getFromNodeMap(btnTag,3))		' split module and sub
'	If fh_CallBackSub.Length = 2 Then 
	If getFromNodeMap(btnTag,3) <> "" Then
		CallSubDelayed2(fh_module,getFromNodeMap(btnTag,3),btnTag)	' there is a callback
		Return
	End If
	If CheckErrors(btnTag) Then
		If fh_yesToExit Then				
			For i = 0 To hiddensMap.Size - 1' add hiddens fields
				fh_Data.Put(hiddensMap.GetKeyAt(i),hiddensMap.GetValueAt(i))
			Next
			handleEvents(Array As Object ("fh_end","End"))
			fh_panel.RemoveAllNodes
			CallSubDelayed2(Me,"fh_answer",fh_Data)
		End If
	End If
End Sub
Private Sub CheckErrors(btnTag As String)	As Boolean	' for button end ComboBox aka button list
	Dim notError As Boolean = True
	Dim fieldError As Boolean
	Dim wdgtValue As String
'	Dim wdgl As TextField
	Dim wdgl As Label
	Private signal(1) As String
	signal(0) = ""
	For i = 0 To nElem -1
		fieldError = False
		field = Elem.GetValueAt(i)
		If field(0) = "B" Or field(0) = "C" Then Continue
		Dim mandatory As Boolean = required.ContainsKey(field(1))
		wdgtValue = valueOf(field(1))
		wdgl = getFromNodeMap(field(1),2)
		CSSUtils.SetStyleProperty(wdgl,"-fx-text-fill","black")
		If mandatory And wdgtValue = "" Then notError = Not(setError(wdgl,signal,"Required"))
		If checks.ContainsKey(field(1)) Then
			Private check As List = checks.Get(field(1))			
			For j = 0 To check.Size - 1
				Dim strCheck(2) As String =  check.Get(j)
				Matcher1 = Regex.Matcher2(".+\s*(=|<=|>=|<>|>|<|is)\s*(.*)",Regex.CASE_INSENSITIVE,strCheck(0))
				If Not(Matcher1.Find) Then Continue
				Dim operand As String = deMask(Matcher1.Group(2))
				Dim operator As String = Matcher1.Group(1)
				If operator.ToLowerCase <> "is" Then
					If Elem.ContainsKey(operand) Then operand = valueOf(operand)	' compare with field
					If Not(compare(numericTypes.GetDefault(field(0),False),valueOf(field(1)),operator,operand)) Then 
						fieldError = setError(wdgl,signal,strCheck(1))
					End If
				Else
					If operand.ToLowerCase() = "mail" Then 
						If Not(Regex.IsMatch("^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$|\s*",wdgtValue)) Then 
							fieldError = setError(wdgl,signal,strCheck(1))
						End If
					Else 		' my be a regular expression
						If Not(Regex.IsMatch(deMask(operand),wdgtValue)) Then fieldError = setError(wdgl,signal,strCheck(1))
					End If
				End If
				If fieldError Then notError = False
			Next
		End If
	Next
	If notError Then		
		fh_Data.Put("fh_button",btnTag)
		For i=0 To nElem -1		' take data 
			field = Elem.GetvalueAt(i)
			If field(0) <> "C" Then fh_Data.Put(field(1),valueOf(field(1)))
		Next
	End If
	Return notError
End Sub
Private Sub compare(Numeric As Boolean,wdgtValue As String, operator As String, operand As String) As Boolean
	Dim cfr As Int = 1	' means equal
	If Numeric Then		' numeric field
		numericTypes.GetDefault(field(0),False)
		If wdgtValue = "" Then Return True			' no data - no compare
		If Not(IsNumber(operand)) Then Return True	' no data - no compare
		If wdgtValue > operand Then cfr = 2
		If wdgtValue < operand Then cfr = 4
	Else
		Dim cfr As Int = wdgtValue.CompareTo(operand)
		If cfr > 0 Then cfr = 2
		If cfr < 0 Then cfr = 4
		If cfr = 0 Then cfr = 1
	End If
	If Bit.And(cfr,comparator.Get(operator)) = 0 Then Return False
	Return True
End Sub
Private Sub setError(l As Label,signal() As String,s As String) As Boolean
	CSSUtils.SetStyleProperty(l,"-fx-text-fill","red")
	If s <> "" Then signal(0) = signal(0) & Chr(10) & s
	Return True
End Sub
Private Sub handleEvents(parms() As Object) As Boolean
	If fh_handleSub <> "" Then
		CallSub2(fh_module,fh_handleSub,parms)
	End If
End Sub
private Sub comboCMX_ValueChanged(value As String)
	Dim cmb As ComboBox = Sender
	Dim typeWidget As String = getNodeType(cmb.Tag)
	handleEvents(Array As Object (cmb.Tag,"CLICK",cmb,value))
	Dim txtArea As TextArea = getFromNodeMap(cmb.tag,0)
	If Not(txtArea.Text.Contains(value)) Then
		If txtArea.Text <> ""  Then  txtArea.Text =  txtArea.Text & Chr(10)
		txtArea.Text = txtArea.Text & value
	End If
End Sub
private Sub combos_ValueChanged(value As String)
	Dim cmb As ComboBox = Sender
	Dim typeWidget As String = getNodeType(cmb.Tag)
	handleEvents(Array As Object (cmb.Tag,"CLICK",cmb,value))
	If typeWidget = "CMB" And nElem = 1 Then		' only one ComboBox
		handleEvents(Array As Object ("fh_end","End"))
		fh_Data.Put(field(1),valueOf(field(1)))
		CallSubDelayed2(fh_module,fh_returnSub,fh_Data)
		cleanForm
		cmb.TooltipText = getFromNodeMap(cmb.Tag,3)
	End If
End Sub
Private Sub Combos_SelectedIndexChanged(Position As Int, Value As Object)
End Sub
Private Sub RadioButton_SelectedChange(selected As Boolean)
	If selected Then
		Dim rdb As RadioButton= Sender
		Dim a() As Object = widgetRef.get(rdb.Tag)
		a(3) = rdb
		widgetRef.Put(rdb.tag,a)
		handleEvents(Array As Object (rdb.tag,"CLICK",Sender,mapValues.get(rdb.Tag & rdb.text)))
	End If
End Sub
Sub txt_FocusChanged (HasFocus As Boolean)
	focusedText = Sender
	handleEvents(Array As Object (focusedText.tag,iIF(HasFocus,"FOCUS","LFOCUS"),Sender,focusedText.text))
'	If HasFocus Then
'		If getNodeType(focusedText.Tag) = "T" Then startVoiceRec
'		If tipsMap.ContainsKey(focusedText.Tag) Then fx.ToastMessageShow(tipsMap.get(focusedText.Tag),True)
'	Else' control field
'		fx.Msgbox(act,focusedText.text,focusedText.tag)
'	End If
End Sub
Sub txt_TextChanged(Old As String, New As String)
	If New = "" Then Return
	If IsUpdatingText = True Then Return
	IsUpdatingText = True
	Dim txt As TextField = Sender
	Dim selStart As Int = txt.SelectionStart
	Dim nodeType As String = getNodeType(txt.Tag)
	If nodeType = "N" Or nodeType = "DN" Then
		Dim pattern As String = "^[-+]?\d+$"	' integer signed pattern
		If nodeType = "DN" Then pattern = "^[-+]?\d+(\.\d*)?$"	' decimal signed pattern
		If Not(Regex.IsMatch(pattern,New)) Then
			txt.Text = Old
			txt.SetSelection(selStart-1,selStart-1)
		End If
	End If
	IsUpdatingText = False
End Sub
Private Sub checkBox_CheckedChange(Checked As Boolean)
	Dim ckb As CheckBox = Sender
	handleEvents(Array As Object (ckb.tag,"CHK",Sender,iIF(Checked,1,0)))
End Sub
Private Sub Slide_ValueChange (Value As Double)
	Dim slideValue As Double,dec As Int,txtSlider As TextField
	Dim sld As Slider = Sender
	txtSlider = getFromNodeMap(sld.Tag,3)
	If getFromNodeMap(sld.Tag,1) = "QS" Then
		Private listQs As List = Limits.Get(sld.Tag)
		txtSlider.text = listQs.Get(Value)
		slideValue = Floor(Value)
	Else
'		txtSlider.text = Value
		dec = Floor(Logarithm(Limits.get(sld.Tag & "Delta"),10))	' delta
		txtSlider.text = NumberFormat(Value,1,0)
		If dec < 3 Then txtSlider.text = NumberFormat(Value,1,-dec+2)
	End If
	handleEvents(Array As Object (sld.Tag,"SLIDE",sld,slideValue,getFromNodeMap(sld.tag,3)))
End Sub
Sub toText(msk As String, values() As Object) As String
	Dim k,j=0 As Int
	Dim str As String
	Dim mtc As Matcher
	Dim strMatch As String = "%\d{0,2}\.\d|%\d{0,2}"	' accept % %n %nn %nn.n
	Dim editFormat() As String
	mtc = Regex.Matcher(strMatch,msk)
	Do While mtc.Find = True
    	k = msk.IndexOf(mtc.Match)
		If j < values.Length Then
			editFormat = Regex.Split("\.","0" & mtc.Match.SubString(1) & ".0.0")
			Select TypeOf(values(j))
				Case "Integer","Double"
					str = NumberFormat2(values(j),0,editFormat(1),editFormat(1),True)
					If editFormat(0) > 0 Then str = Right(fillString(editFormat(0)) & str,editFormat(0)) 
				Case Else
					str = values(j)
					If editFormat(0) > 0 Then str = Left(values(j) & fillString(editFormat(0)),editFormat(0))
			End Select
			msk = Left(msk,k) & str & msk.SubString(k+mtc.Match.Length)
		End If
		j = j+1
	Loop
	Return msk
End Sub
Sub TypeOf(obj As Object) As String
	Dim t() As String = Regex.Split("\.",GetType(obj))
	Return t(t.Length-1)
End Sub
Private Sub fillString(n As Int) As String
'	Dim i As Int
	Dim str As String = ""
	For i=0 To n Step 10
		str = str & "          "
	Next
	Return Left(str,n)
End Sub
Private Sub setInMap(fld As String,pos As Int,val As Object)	' From field widget map parameters field, position
	Dim aWdg() As Object
	If Not(widgetRef.ContainsKey(fld)) Then Return 
	aWdg = widgetRef.get(fld)
	If pos < aWdg.Length Then 
		aWdg(pos) = val
		widgetRef.Put(fld,aWdg)
	End If
End Sub
Sub pathinfo(dir As String) As Map
	Dim fInfo As Map = CreateMap("dirname":"","extension":"","filename":"","basename":"")
	Dim k As Int = dir.LastIndexOf("\")
	If k >= 0 Then 	fInfo.Put("dirname",Left(dir,k))
	Dim fl As String = dir.SubString(k+1)
	fInfo.Put("basename",fl)
	k = fl.LastIndexOf(".")
	fInfo.Put("filename",fl)
	If k >= 0 Then 
		fInfo.Put("filename",Left(fl,k))
		fInfo.Put("extension",fl.SubString(k+1))
	End If
	Return fInfo
End Sub
Sub startVoiceRec()
'	VR.Listen 'calls the voice recognition external activity
End Sub
Private Sub addCheck(sField As String,check() As String)
	Private a As List
	a.Initialize
	If checks.ContainsKey(sField) Then a = checks.Get(sField)
	a.add(check)
	checks.Put(sField,a)	
End Sub
Sub VR_Result (Success As Boolean, Texts As List)
	If Success = True Then
		Dim a() As Object = Array As Object(focusedText.tag,"VREND",focusedText,Texts.get(0))
		handleEvents(a)
		focusedText.text = iIF(focusedText.text = "",  a(3), focusedText.text & Chr(13) & Chr(10) &  a(3))
		startVoiceRec
	End If
End Sub
Sub enable(Name As String)
	SetWidget(Name,"Enable")
End Sub
Sub Disable(Name As String)
	SetWidget(Name,"Disable")
End Sub
Private Sub SetWidget(Name As String, option As String)
	Dim aWdg() As Object = widgetRef.GetDefault(Name,Array As Object(0))	
	If aWdg.Length = 1 Then Return	' key exist?
	Dim v As Node = aWdg(0)
	Dim opt As String = option.ToLowerCase
	Select opt
		Case "enable","disable"
			If TypeOf(v) = "Button" Or TypeOf(v) <> "BALayout" Then 
				v.Enabled = iIF(opt = "enable",True,False)
			Else
				pnl = aWdg(0)
				For i = 0 To pnl.NumberOfNodes -1
					pnl.GetNode(i).Enabled = iIF(opt = "enable",True,False)
				Next
			End If
	End Select
End Sub
Sub getHandle(Name As String) As Object
	Dim aWdg() As Object = widgetRef.GetDefault(Name,Array As Object(0))
	Return aWdg(0)
End Sub
Private Sub getFromNodeMap(fld As String,pos As Int) As Object	' From field widget map parameters field, position
	Dim aWdg() As Object = widgetRef.GetDefault(fld,Array As Object(0))
	If aWdg.Length = 1 Then Return 0 
	aWdg = widgetRef.get(fld)
	If pos < aWdg.Length Then Return aWdg(pos)
	Return 0
End Sub
Sub getNodeType(Name As String) As String
	Return getFromNodeMap(Name,1)
End Sub
Sub getSetDate(Name As String, value As String) As String	' if <> 0 is set valur
	Dim a() As Object = widgetRef.get(Name)
	Dim dt As DatePicker = a(0)
	Dim field() As String = Elem.Get(dt.tag)
	Dim dateFormat As String = DateTime.DateFormat
	If field(5) <> "" Then DateTime.DateFormat = field(5)
	If value <> 0 Then
		dt.dateTicks = DateTime.DateParse(value)
	End If
	Dim valueOfData As String = DateTime.Date(dt.DateTicks)
	DateTime.DateFormat = dateFormat
	Return valueOfData
End Sub
Sub valueOf(Name As String) As String
	Dim a() As Object
	If widgetRef.ContainsKey(Name) Then
		a = widgetRef.get(Name)
		Select a(1)		' node type
			Case "DATE"
				Return getSetDate(Name,0)
			Case "TIME"	' for now TIME is a seek bar for only hour
				Dim dt As DatePicker = a(0)
				Dim field() As String = Elem.Get(dt.tag)
				Dim timeFormat As String = DateTime.TimeFormat
				If field(5) <> "" Then DateTime.DateFormat = field(5)
				Dim valueOfData As String = DateTime.Time(dt.DateTicks)
				DateTime.timeFormat = timeFormat
				Return valueOfData
			Case "CMB","CMT"
				Dim cmb As ComboBox = a(0)
				If a(1) = "CMB" Then Return mapValues.GetDefault(Name & cmb.Value,"")
				If cmb.Value = Null Then Return ""
				Return cmb.Value
			Case "CMX"
				Dim wdgTA As TextArea = a(0)
				Return wdgTA.text				
			Case "CKB"
				Dim chk As CheckBox = a(0)
				Return (iIF(chk.Checked,"1","0"))
			Case "S","QS"		' Slider
				Dim txt As TextField = a(3)
				If a(1) = "S" Then Return txt.text
				Return mapValues.get(Name & txt.text)
			Case "U"		' Unmodifiable
				Dim uLbl As Label = a(0)
				Return uLbl.text
			Case "R"		' RadioButton
				If a(3) = 0 Then Return ""
				Dim rdb As RadioButton = a(3)
				Return mapValues.get(Name & rdb.text)
			Case "B","BG"
				Return Name
			Case "H"
				Return hiddensMap.GetDefault(Name,"")
			Case "C"	' comment
			Case else		' text Nodes also CMX combo text
				Dim wdgT As TextField = a(0)
				Return wdgT.text
		End Select	
	End If
	Return ""
End Sub
Sub implode(sep As String,obj As List) As String
	Return implodeFrom(sep,obj,0,obj.Size)
End Sub
Sub implodeFrom(sep As String, obj As List, From As Int, At As Int) As String
	Dim implStr As String = ""
	For j = obj.size -1 To From Step -1	' delete last empty items 
		If obj.Get(j) <> "" Then Exit
	Next
	For i = From To Min(At,j)
	     implStr =  implStr & sep & obj.Get(i)
	Next
	If implStr.Length > 0 Then Return implStr.SubString(1)
	Return ""
End Sub
Sub setValue(Name As String,Value As String)
	Dim wdg As Object = iIF(widgetRef.ContainsKey(Name),getFromNodeMap(Name,0),-1)
	If wdg = -1 Then Return	' no field
	Select getNodeType(Name)
		Case "CMB","CMT"
			Dim cmb As ComboBox = wdg
			cmb.SelectedIndex = cmb.Items.IndexOf(Value)
		Case "CMX"
			Dim cmb As ComboBox = getFromNodeMap(Name,3)
			Dim txtArea As TextArea = wdg
				txtArea.Text = Value
		Case "S"
			Dim sld As Slider = wdg
			If IsNumber(Value) Then 
				sld.Value = Value
			Else
				Dim txt As TextField = getFromNodeMap(sld.Tag,3)
				sld.Value = 0	' Limits.Get(Name & "Min")	' set un
				txt.Text = ""
			End If
		Case "QS"
			Dim sld As Slider = wdg
			Dim txt As TextField = getFromNodeMap(sld.Tag,3)
			Private listQs As List = Limits.Get(Name)
			listQs.IndexOf(Value)
			sld.Value = listQs.IndexOf(Value)
		Case "T","N","DN","P","F","WF","TIME"
			Dim txt As TextField = wdg
			txt.text = Value
		Case "CKB"
			Dim chk As CheckBox = wdg
			chk.Checked = iIF(Left(Value,5).ToLowerCase = "check" Or Value = "1", True,False)
		Case "U" 
		Case "R"
			pnl = getFromNodeMap(Name,0)
			Dim v As Node
			setInMap(Name,3,0)
			For i = 0 To pnl.NumberOfNodes -1
				v = pnl.GetNode(i)
				If TypeOf(v) = "RadioButton" Then
				Dim rdb As RadioButton = pnl.GetNode(i)
					rdb.Selected = False
					If rdb.text = Value Or rdb.text = mapValues.GetDefault(Name & Value,"") Then 
						rdb.selected = True
						setInMap(Name,3,rdb)
					End If
				End If
			Next
		Case "B","BG"
			Dim btnx As Node = wdg
			btnx.Enabled = iIF(Left(Value,3).ToLowerCase = "dis",False,True)
		Case "DATE"
			getSetDate(Name,Value)
	End Select
End Sub
Sub decodeColor(C As String) As String
	Dim Match As Matcher = Regex.Matcher("^[\daAbBcCdDeEfF]{1,8}$", C)	' from 1 to eight exadecimals digit
	If Not(Match.Find) Then Return C 	' unchanged, presume color or css style color or worse
	If C.Length = 3 Or C.Length = 1 Then C = Regex.Replace2("[\dABCDEF]",Regex.CASE_INSENSITIVE, C, "$0F")
	C = "FF000000".SubString2(0,8-C.Length) & C
	Dim cssColor As String = "rgba("
	For i=2 To 7 Step 2
		cssColor = cssColor & Bit.ParseInt(C.SubString2(i,i+2),16) & ","
	Next
	cssColor = cssColor & (Bit.ParseInt(C.SubString2(0,2),16)/255) & ")"	'rgba(<integer> , <integer> , <integer> , <number>)
	Return cssColor
End Sub
Private Sub addButton(Caption As String,Name As String,x As Int,y As Int) As Button
	Dim btnx As Button
	btnx.initialize(Name)
	btnx.TextSize = 12
	btnx.Text = Caption
	fh_panel.AddNode(btnx,x,y,Caption.Length*10,28)
	Return btnx
End Sub
private Sub setText(f() As String) As TextField
	Dim t As TextField
	If f(0) = "P" Then
		t.InitializePassword("txt")
	Else
		t.Initialize("txt")
	End If
	If f(6) <> "" Then t.TooltipText = f(6)
	t.Tag = f(1)
	CSSUtils.SetStyleProperty(t, "-fx-font-size", "12")
	CSSUtils.SetStyleProperty(t, "-fx-text-fill","black")
	Return t
End Sub
Sub createMenu(menuParms As String) As MenuBar
	Dim menu As Menu
	Dim menubar As MenuBar
	Dim widgets() As String = Regex.Split(";\s*",menuParms & ";Menu")
	menubar.Initialize("")
	Dim mapMenu As Map = CreateMap()
	Dim mapFathers As Map = CreateMap()
	For iw = 0 To widgets.Length - 1
		field = Regex.Split(",", widgets(iw) & ",,,,,,*")
		field(field.Length-1) = ""	' remove *
		menu.Initialize(field(0),"handleMenu")
		If Not(mapMenu.ContainsKey(field(0))) Then
			If mapMenu.Size > 0 Then
				' adding to menubar
				For Each k As String In mapMenu.Keys					
					Dim a() As Object = mapMenu.Get(k)
					If a(0) = "" Then
						menubar.Menus.Add(a(1))
					Else							
						Dim a2() As Object = mapMenu.Get(a(0))	' dat of father
						Dim mn As Menu = a2(1)
						If mapFathers.ContainsKey(k) Then		' item is menu (father)
							mn.MenuItems.Add(a(1))
						Else
							Dim x As MenuItem
							x.Initialize(k,"handleMenu")
							x.Tag = a(2)
							mn.MenuItems.Add(x)
						End If
					End If
				Next
				mapMenu.Clear
				mapFathers.Clear
			End If
		End If
		mapFathers.Put(field(0),"")	' is father
		If Not(mapMenu.ContainsKey(field(0))) Then 
			mapMenu.Put(field(0),Array As Object("",menu,field(2)))
		Else
		End If
		menu.Initialize(field(1),"handleMenu")
		mapMenu.Put(field(1),Array As Object(field(0),menu,field(2)))
	Next
	Return menubar
End Sub
Sub handleMenu_Action
	Dim mi As MenuItem = Sender
	Dim dt() As String
	dt = Regex.Split("\.", "Main." & mi.tag)
	CallSub(dt(dt.Length-2),dt(dt.Length-1))
End Sub
Private Sub textWidth (txt As String) As Int
	lbl.Text = txt
	frm.RootPane.AddNode(lbl, 0, 0, -1, -1)
	lbl.Snapshot
	lbl.RemoveNodeFromParent
	Return lbl.Width
End Sub
Sub CopyObject(Obj As Object) As Object
	Dim raf As RandomAccessFile
	raf.Initialize(File.Dirtemp, "1.dat", False)
	raf.WriteObject(Obj, True, 0)
	Dim newObj As Object
	newObj = raf.ReadObject(0)
	raf.Close
	Return newObj
End Sub